:
# $Id: grab-pics.sh,v 1.4 2009/01/03 00:13:03 sjg Exp sjg $

. /etc/rc_d/ask.sh

grabFunc=grab_All
copyFunc=link

export copyFunc grabFunc

Exists() {
	[ -f $1 ]
}

link() {
	$ECHO ln -sf "$@"
}

copy() {
	$ECHO cp -p "$@"
}

grab_subs() {
	dir=$1
	file=$2
	shift 2
	for sub in $*
	do
		[ -d $dir/$sub ] || continue
		find $dir/$sub -name "$file" -print
	done | sed "s,$dir/\(.*\)/[^/]*\$,& \1," | while read src dest
	do
		[ -d $dest ] || mkdir -p $dest
		if [ -d $dest ]; then
			$copyFunc $src $dest
		fi
	done
}

grab_raw() {
	dir=$1
	file=$2
	if [ -d $dir/raw ]; then
		if [ -s $dir/raw/$file ]; then
			[ -d raw ] || $ECHO mkdir -p raw
			[ -s raw/$file ] || $copyFunc $dir/raw/$file raw
			exif1=`echo $file | sed 's,\.[^\.]*$,.exif1,'`
			if [ -s $dir/raw/$exif1 ]; then
				[ -s raw/$exif1 ] || $copyFunc $dir/raw/$exif1 raw
			fi
		fi
	fi
}

grab_iPhoto() {
#	 Exists $* || return 1
	for f in $*
	do
		# we only want the original image
		case $f in
		*-[tw].jpg) continue;;
		*.jpg) ;;
		*) continue;;
		esac
		echo "Grabbing $f ..."
		$copyFunc $f .
	done
	:
}

grab_All() {
#	 Exists $* || return 1
	echo "Grabbing $1 ..."
	for f in $*
	do
		case $f in
		*.htm*) ;;
		*.bak|*.old|*~) ;;
		*)
			file=`basename $f`
			[ -s $file ] || $copyFunc $f .
			#grab_raw `dirname $f` $file
			grab_subs `dirname $f` $file raw print $IMAGE_DIR img image
			if [ -d ${IMAGE_DIR:-/dev/null} ]; then
				case $f,$file in
				*/$IMAGE_DIR/*-w.ref) ;;
				*-w.ref) rm -f $file;; # need to regen
				*htm*|*-[tw].jpg|*.exif1|*.txt|*.ref) ;;
				*) mv $file $IMAGE_DIR;;
				esac
			fi
			;;
		esac
	done
	:
}

grab1() {
	Exists $* || return 1
	$grabFunc $*
	:
}

grab() {
	day=${2:-$day}
	month=${3:-$month}
	year=${4:-$year}
	
	case "$1" in
	*/*)
		grab1 $1* && return
		grab1 $pics/$1* && return
		;;
	esac
	grab1 $pics/$year$month$day$1* ||
	grab1 $pics/$year/$month/$year$month$day$1* ||
	grab1 $pics/$year/$month/$day/$year$month$day$1* ||
	grab1 $pics/$year/$month/$day*/$year$month$day$1* && return 0
	case "$day" in
	*/*)
		sub=`dirname $day` d=`basename $day`
		grab1 $pics/$year/$month/$sub/$year$month$d$1*
		;;
	esac
}

while :
do
	case "$1" in
	*=*) eval "$1"; shift;;
	--) shift; break;;
	-n) ECHO=echo; shift;;
	--copy) copyFunc=copy; shift;;
	--link) copyFunc=link; shift;;
	--iPhoto)
		grabFunc=grab_iPhoto
		copyFunc=copy
		shift
		;;
	--img)  IMAGE_DIR=img; shift; mkdir -p $IMAGE_DIR;;
	--imag*) IMAGE_DIR=$2; shift 2; mkdir -p $IMAGE_DIR;;
	*) break;;
	esac
done

pics=${1:-/pics}

IMAGE_DIR=${IMAGE_DIR:-img}

if [ -t 0 ]; then
	cat <<!EOM
This tool helps you grab pics for a collection.
You specify YYYY mm [subdir/]dd NN[N] to grab YYYYmmddNN*
to grab pics from the next day you need only specify dd and NN.
!EOM

	while :
	do
		ask p "Grab? [[[YYYY] [mm]] [dd]] NN[N]"
		case "${p:-q}" in
		q*) exit 0;;
		esac
		set -- $p
		grab $4 $3 $2 $1
	done
else
	echo "Grabbing bulk... expect YYYY mm dd NN[N]"
	while read YYYY mm dd NN
	do
		case $YYYY in
		*/*.*)
			it=`echo $YYYY | sed 's,\.[^.]*$,,'`
			grab $it && continue
			eval `basename $YYYY$mm$dd$NN | sed 's,^\(....\)\(..\)\(..\)\(..[0-9]*\).*,YYYY=\1 mm=\2 dd=\3 NN=\4,'`
			;;
		??????*)
			eval `echo $YYYY$mm$dd$NN | sed 's,^\(....\)\(..\)\(..\)\(..[0-9]*\).*,YYYY=\1 mm=\2 dd=\3 NN=\4,'`;;
		esac
		grab $NN $dd $mm $YYYY
	done
fi

